TODO:
- [ ] support multiple type lists w/ array types, eg the () parts of these:

```php
/** @var int */
/** @var (int) */
/** @var int[] */
/** @var (int)[] */
/** @var int|string */
/** @var int|(string) */
/** @var (int|string) */
/** @var (int|string)[] */
/** @var (int[]|string[]) */
/** @var (int[]|string[])[] */
```

- [x] support Psalm simple array types: https://psalm.dev/docs/annotating_code/type_syntax/array_types/

```php
/** @return array<TKey, TValue> */
/** @psalm-param list<string> $arr */
```

- [x] support Psalm array object types:

```php
/** @return array{foo: string, bar: int} */
/** @return array{optional?: string, bar: int} */
```

- [ ] Psalm annotations: https://psalm.dev/docs/annotating_code/supported_annotations/
  - basically, anything that stars w/ `@psalm-`

- [x] Psalm `@var` "off label" usage

- [ ] phpStan annotations
  - https://phpstan.org/writing-php-code/phpdoc-types
  - https://phpstan.org/blog/generics-in-php-using-phpdocs
  - https://phpstan.org/writing-php-code/phpdocs-basics
  - @mixin
  - @template, @template-covariant, @extends, @implements
  - @phpstan-<var, param, return, template>
  - @phpstan-type and @phpstan-import-type


  - types:
    - class-string
    - array-key
    - integer, boolean
    - true, false, null?
    - scalar
    - iterable, resource, object
    - positive-int, negative-, int<range min, range max>
    - non-empty-array
    - iterable-, numeric-, non-empty-, and literal-string
    - never, never-return, never-returns, no-return
    - callable has a rich syntax for passing around anonymous funcs

- [x] PHPUnit annotations: https://phpunit.readthedocs.io/en/9.5/annotations.html
    - [ ] differentiate annotations that take no args, types, etc
